'Compilable Example:
'  Typical DIR syntax:   DIR c:\temp*.bas /s /b    /b=bare /s=subfolders
#Compiler PBWin 10
#Compile Exe
#Dim All
#Include "win32api.inc"
#Resource Icon, aaa, "images\search.ico"

%IDC_Switches      = 500
%IDC_SearchString  = 501
%IDC_FileSpec      = 502
%IDC_ParentFolder  = 503
%IDC_Search        = 504
%IDC_Results       = 505
%IDC_Select        = 506
%IDC_CaseSensitive = 507
%IDC_SubFolders    = 508

Global hDlg As Dword, switches, searchstring, filespec, parentfolder As String
Global casesensitive, subfolders As Long
Function PBMain() As Long
   Local style&
   style& = %WS_TabStop Or %WS_Border Or  %ES_Left Or %ES_AutoVScroll _
             Or %ES_MultiLine Or %ES_NoHideSel Or %ES_WantReturn Or %WS_VScroll Or %WS_ClipSiblings
   Dialog New Pixels, 0, "gbBatSearch v1.1:    Search Files for Text Using DIR",300,300,400,200, %WS_OverlappedWindow, 0 To hDlg
   Dialog Set Icon hDlg, "aaa"
   Control Add Button, hDlg, %IDC_Search, "&Search", 10,10,50,20
   Control Add CheckBox, hDlg, %IDC_CaseSensitive, "Case Sensitive", 70,5,100,20
   Control Add CheckBox, hDlg, %IDC_SubFolders, "SubFolders", 70,20,100,20
   Control Add TextBox, hDlg, %IDC_SearchString, "", 180,10,110,20
   Control Add TextBox, hDlg, %IDC_FileSpec, "", 300,10,110,20
   Control Add Button, hDlg, %IDC_Select, "&Folder", 10,40,50,20
   Control Add TextBox, hDlg, %IDC_ParentFolder, "", 70,40,300,20
   Control Add ListBox, hDlg, %IDC_Results,,10,70,400,100, %WS_TabStop Or %LBS_Notify Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local w,h As Long, temp$
   Select Case Cb.Msg
      Case %WM_InitDialog    : Settings_INI "get"   : Control Set Focus hDlg, %IDC_Switches
      Case %WM_Destroy       : GetArguments         : Settings_INI "save"
      Case %WM_Command
          Select Case Cb.Ctl
              Case %IDC_Search    : Search
              Case %IDC_Select    : SelectFolder
              Case %IDC_Results
                  If Cb.CtlMsg = %LBN_DblClk Then
                      ListBox Get Text hDlg, %IDC_Results To temp$
                      w = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  End If
              Case %IdOk
                  If GetFocus = GetDlgItem(hDlg,%IDC_Results) Then
                      ListBox Get Text hDlg, %IDC_Results To temp$
                      w = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  Else
                      Search
                  End If
          End Select
       Case %WM_Size
           Dialog Get Client hDlg To w,h :
           Control Set Size hDlg, %IDC_ParentFolder, w-80, 20
           Control Set Size hDlg, %IDC_Results, w-20, h-80
   End Select
End Function

Sub SelectFolder
   Local title$, start$, flags&, folder$, sfolder$
   Control Get Text hDlg, %IDC_ParentFolder To sFolder$
   title$ = "Select Starting Folder for Search"
   start$ = sFolder
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then Control Set Text hDlg, %IDC_ParentFolder, folder$
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long, xResult, yResult, tempz, INIFileName As AsciiZ * %Max_Path
   'set ini filename
   INIFileName = Exe.Path$ + "gbbatsearch_dir.ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top
      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "430", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "200", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height
      'get value for string variables
      GetPrivateProfileString "All", "searchstring", "search string", tempz, %Max_Path, INIFileName : searchstring = tempz
      GetPrivateProfileString "All", "filespcc", "*.bas *.txt", tempz, %Max_Path, INIFileName : filespec = tempz
      GetPrivateProfileString "All", "parentfolder", Exe.Path$, tempz, %Max_Path, INIFileName : parentfolder = tempz
      'get value for numeric variables
      Getprivateprofilestring "All", "CaseSensitive", "0", tempz, %Max_Path, INIFileName
      CaseSensitive = Val(tempz)
      Getprivateprofilestring "All", "SubFolders", "0", tempz, %Max_Path, INIFileName
      SubFolders = Val(tempz)

      Control Set Check hDlg, %IDC_CaseSensitive, CaseSensitive
      Control Set Check hDlg, %IDC_SubFolders, SubFolders
      Control Set Text hDlg, %IDC_Switches, switches
      Control Set Text hDlg, %IDC_SearchString, searchstring
      Control Set Text hDlg, %IDC_FileSpec, filespec
      Control Set Text hDlg, %IDC_ParentFolder, parentfolder

   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      Dialog Get Client hDlg To x,y
      'save string variables
      WritePrivateProfileString "All", "searchstring", (searchstring), INIFileName
      WritePrivateProfileString "All", "filespec", (filespec), INIFileName
      WritePrivateProfileString "All", "parentfolder", (parentfolder), INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "SubFolders", (Str$(SubFolders)), INIFileName
      WritePrivateProfileString "All", "CaseSensitive", (Str$(CaseSensitive)), INIFileName

   End If
End Sub

Sub GetArguments
    Control Get Check hDlg, %IDC_CaseSensitive To CaseSensitive
    Control Get Check hDlg, %IDC_SubFolders To SubFolders
    If SubFolders Then switches = " /b  /s " Else switches = " /b "
    Control Get Text hDlg, %IDC_SearchString To searchstring
    Control Get Text hDlg, %IDC_FileSpec To filespec
    Control Get Text hDlg, %IDC_ParentFolder To parentfolder
    parentfolder = Trim$(parentfolder,"\")
End Sub

Sub Search
    Local text$, fName$, sterm$, outfile$, j,lenS As Long
    MousePtr 11
    GetArguments           'get search parameters
    If CaseSensitive = 0 Then sTerm$ = LCase$(searchstring) Else sTerm$ = searchstring
    outfile$ = Exe.Path$ + "gbbatsearch_dir.txt"
    ListBox Reset hDlg, %IDC_Results

    'put Dir results in outfile$
    If IsFile(outfile$) Then Kill outfile$
    For j = 1 To ParseCount(filespec,$Spc)
        Shell ("cmd /C Dir " + parentfolder + "\" + Parse$(filespec,$Spc,j) + switches + " >> " + $Dq + outfile$ + $Dq, 0)
    Next j

    'put file names from file which contain the string into the listbox
    lenS = Len(sterm$)
    Open outfile$ For Input As #1
    While IsFalse(Eof(1))
        Line Input #1, fName$
        fName$ = (IIf$(switches=" /b ",parentfolder + "\","") + fName$)
        If lenS Then
            Open fName$ For Binary As #2 : Get$ #2, Lof(2), text$ : Close #2
            If CaseSensitive=0 Then text$ = LCase$(text$)
            If InStr(text$,sterm$) Then ListBox Add hDlg, %IDC_Results, fName$
        Else
            ListBox Add hDlg, %IDC_Results, fName$
        End If
    Wend
    Close #1
    MousePtr 0
End Sub
